codeforces 599 C. Day at the Beach【思维】

11 篇文章 0 订阅
10 篇文章 0 订阅
C. Day at the Beach
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

One day Squidward, Spongebob and Patrick decided to go to the beach. Unfortunately, the weather was bad, so the friends were unable to ride waves. However, they decided to spent their time building sand castles.

At the end of the day there were n castles built by friends. Castles are numbered from 1 to n, and the height of the i-th castle is equal tohi. When friends were about to leave, Squidward noticed, that castles are not ordered by their height, and this looks ugly. Now friends are going to reorder the castles in a way to obtain that condition hi ≤ hi + 1 holds for all i from 1 to n - 1.

Squidward suggested the following process of sorting castles:

  • Castles are split into blocks — groups of consecutive castles. Therefore the block from i to j will include castles i, i + 1, ..., j. A block may consist of a single castle.
  • The partitioning is chosen in such a way that every castle is a part of exactly one block.
  • Each block is sorted independently from other blocks, that is the sequence hi, hi + 1, ..., hj becomes sorted.
  • The partitioning should satisfy the condition that after each block is sorted, the sequence hi becomes sorted too. This may always be achieved by saying that the whole sequence is a single block.

Even Patrick understands that increasing the number of blocks in partitioning will ease the sorting process. Now friends ask you to count the maximum possible number of blocks in a partitioning that satisfies all the above requirements.

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 100 000) — the number of castles Spongebob, Patrick and Squidward made from sand during the day.

The next line contains n integers hi (1 ≤ hi ≤ 109). The i-th of these integers corresponds to the height of the i-th castle.

Output

Print the maximum possible number of blocks in a valid partitioning.

Examples
input
3
1 2 3
output
3
input
4
2 1 3 2
output
2

/*
    题意:给你一个序列,要求你从小到大排序,你可以划分成一个块一个块地进行块内排序,问你最多能分成几个块
    类型:思维题
    分析:写了几个例子进行分析:
        3 2 5 4 6,最大分块为[3 2][5 4][6];
        5 4 3 2 1,最大分块为[5 4 3 2 1];
        5 4 2 7 6,最大分块为[5 4 2][7 6];
        从上面几个例子慢慢分析,会发现,当后一区间的最小值大于当前区间的最大值的时候,可以划分出一块;
        每个区间的最小值可以从后往前扫整个数组不断更新当前i的最小值,即
            dp[n-1] = a[n-1];
            for(int i=n-2;i>=0;i--){
                dp[i] = a[i];
                dp[i] = min(dp[i],dp[i+1]);
            }
        预处理完这一块之后进行从前往后统计答案数,顺便更新最大值即可.
        
    感想:一开始读错题意,然后又懒得动手分析,结果卡了蛮久的...
*/
#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;
int a[100005],dp[100005];
int main()
{
    int n;
    cin>>n;
    for(int i=0; i<n; i++)
        scanf("%d",&a[i]);
    dp[n-1] = a[n-1];
    for(int i=n-2; i>=0; i--){
        dp[i] = a[i];
        dp[i] = min(dp[i], dp[i+1]);
    }
    int ans = 1, Max = -0xfffffff;
    for(int i=0; i<n; i++){
        Max = max(Max, a[i]);
        if(dp[i+1] >= Max)
            ans++;
    }
    cout<<ans<<endl;
    return 0;
}





  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值